libcdr::CDRContentCollector Class Reference

`#include <CDRContentCollector.h>`

Inheritance diagram for libcdr::CDRContentCollector:

## Public Member Functions

| CDRContentCollector (CDRParserState &ps, librevenge::RVNGDrawingInterface *painter, bool reverseOrder=true)
| ~CDRContentCollector () override
void | collectPage (unsigned level) override
void | collectObject (unsigned level) override
void | collectGroup (unsigned level) override
void | collectVect (unsigned level) override
void | collectOtherList () override
void | collectPath (const CDRPath &path) override
void | collectLevel (unsigned level) override
void | collectTransform (const CDRTransforms &transforms, bool considerGroupTransform) override
void | collectFillStyle (unsigned, const CDRFillStyle &) override
void | collectFillStyleId (unsigned id) override
void | collectLineStyle (unsigned, const CDRLineStyle &) override
void | collectLineStyleId (unsigned id) override
void | collectRotate (double angle, double cx, double cy) override
void | collectFlags (unsigned flags, bool considerFlags) override
void | collectPageSize (double, double, double, double) override
void | collectPolygonTransform (unsigned numAngles, unsigned nextPoint, double rx, double ry, double cx, double cy) override
void | collectBitmap (unsigned imageId, double x1, double x2, double y1, double y2) override
void | collectBmp (unsigned, unsigned, unsigned, unsigned, unsigned, const std::vector< unsigned > &, const std::vector< unsigned char > &) override
void | collectBmp (unsigned, const std::vector< unsigned char > &) override
void | collectBmpf (unsigned, unsigned, unsigned, const std::vector< unsigned char > &) override
void | collectPpdt (const std::vector< std::pair< double, double > > &points, const std::vector< unsigned > &knotVector) override
void | collectFillTransform (const CDRTransforms &fillTrafo) override
void | collectFillOpacity (double opacity) override
void | collectPolygon () override
void | collectSpline () override
void | collectColorProfile (const std::vector< unsigned char > &) override
void | collectBBox (double x0, double y0, double x1, double y1) override
void | collectSpnd (unsigned spnd) override
void | collectVectorPattern (unsigned id, const librevenge::RVNGBinaryData &data) override
void | collectPaletteEntry (unsigned, unsigned, const CDRColor &) override
void | collectText (unsigned, unsigned, const std::vector< unsigned char > &, const std::vector< unsigned char > &, const std::map< unsigned, CDRStyle > &) override
void | collectArtisticText (double x, double y) override
void | collectParagraphText (double x, double y, double width, double height) override
void | collectStld (unsigned, const CDRStyle &) override
void | collectStyleId (unsigned styleId) override
Public Member Functions inherited from libcdr::CDRCollector
| CDRCollector ()
virtual | ~CDRCollector ()

## Private Member Functions

| CDRContentCollector (const CDRContentCollector &)
CDRContentCollector & | operator= (const CDRContentCollector &)
void | _startDocument ()
void | _endDocument ()
void | _startPage (double width, double height)
void | _endPage ()
void | _flushCurrentPath ()
void | _fillProperties (librevenge::RVNGPropertyList &propList)
void | _lineProperties (librevenge::RVNGPropertyList &propList)
void | _generateBitmapFromPattern (librevenge::RVNGBinaryData &bitmap, const CDRPattern &pattern, const CDRColor &fgColor, const CDRColor &bgColor)

## Private Attributes

librevenge::RVNGDrawingInterface * | m_painter
bool | m_isDocumentStarted
bool | m_isPageProperties
bool | m_isPageStarted
bool | m_ignorePage
CDRPage | m_page
unsigned | m_pageIndex
CDRFillStyle | m_currentFillStyle
CDRLineStyle | m_currentLineStyle
unsigned | m_spnd
unsigned | m_currentObjectLevel
unsigned | m_currentGroupLevel
unsigned | m_currentVectLevel
unsigned | m_currentPageLevel
unsigned | m_currentStyleId
CDRImage | m_currentImage
const std::vector< CDRTextLine > * | m_currentText
CDRBox | m_currentBBox
CDRBox | m_currentTextBox
CDRPath | m_currentPath
CDRTransforms | m_currentTransforms
CDRTransforms | m_fillTransforms
std::unique_ptr< CDRPolygon > | m_polygon
bool | m_isInPolygon
bool | m_isInSpline
std::stack< CDROutputElementList > * | m_outputElementsStack
std::stack< CDROutputElementList > | m_contentOutputElementsStack
std::stack< CDROutputElementList > | m_fillOutputElementsStack
std::queue< CDROutputElementList > * | m_outputElementsQueue
std::queue< CDROutputElementList > | m_contentOutputElementsQueue
std::queue< CDROutputElementList > | m_fillOutputElementsQueue
std::stack< unsigned > | m_groupLevels
std::stack< CDRTransforms > | m_groupTransforms
CDRSplineData | m_splineData
double | m_fillOpacity
bool | m_reverseOrder
CDRParserState & | m_ps

## Constructor & Destructor Documentation

## CDRContentCollector() [1/2]

libcdr::CDRContentCollector::CDRContentCollector | ( | libcdr::CDRParserState & | ps,
|  | librevenge::RVNGDrawingInterface * | painter,
|  | bool | reverseOrder = true )

Referenced by CDRContentCollector(), and operator=().

## ~CDRContentCollector()

libcdr::CDRContentCollector::~CDRContentCollector | ( |  | ) |

override

## CDRContentCollector() [2/2]

libcdr::CDRContentCollector::CDRContentCollector | ( | const CDRContentCollector & |  | ) |

private

## Member Function Documentation

## _endDocument()

void libcdr::CDRContentCollector::_endDocument | ( |  | ) |

private

Referenced by ~CDRContentCollector().

## _endPage()

void libcdr::CDRContentCollector::_endPage | ( |  | ) |

private

Referenced by _endDocument(), collectLevel(), and ~CDRContentCollector().

## _fillProperties()

void libcdr::CDRContentCollector::_fillProperties | ( | librevenge::RVNGPropertyList & | propList | ) |

private

Referenced by _flushCurrentPath().

## _flushCurrentPath()

void libcdr::CDRContentCollector::_flushCurrentPath | ( |  | ) |

private

Referenced by collectLevel().

## _generateBitmapFromPattern()

void libcdr::CDRContentCollector::_generateBitmapFromPattern | ( | librevenge::RVNGBinaryData & | bitmap,
|  | const CDRPattern & | pattern,
|  | const CDRColor & | fgColor,
|  | const CDRColor & | bgColor )

private

Referenced by _fillProperties().

## _lineProperties()

void libcdr::CDRContentCollector::_lineProperties | ( | librevenge::RVNGPropertyList & | propList | ) |

private

Referenced by _flushCurrentPath().

## _startDocument()

void libcdr::CDRContentCollector::_startDocument | ( |  | ) |

private

Referenced by _startPage().

## _startPage()

void libcdr::CDRContentCollector::_startPage | ( | double | width,
|  | double | height )

private

Referenced by collectFlags(), collectGroup(), and collectObject().

## collectArtisticText()

void libcdr::CDRContentCollector::collectArtisticText | ( | double | x,
|  | double | y )

override virtual

Implements libcdr::CDRCollector.

## collectBBox()

void libcdr::CDRContentCollector::collectBBox | ( | double | x0,
|  | double | y0,
|  | double | x1,
|  | double | y1 )

override virtual

Implements libcdr::CDRCollector.

## collectBitmap()

void libcdr::CDRContentCollector::collectBitmap | ( | unsigned | imageId,
|  | double | x1,
|  | double | x2,
|  | double | y1,
|  | double | y2 )

override virtual

Implements libcdr::CDRCollector.

## collectBmp() [1/2]

void libcdr::CDRContentCollector::collectBmp | ( | unsigned | ,
|  | const std::vector< unsigned char > & | )

inline override virtual

Implements libcdr::CDRCollector.

## collectBmp() [2/2]

void libcdr::CDRContentCollector::collectBmp | ( | unsigned | ,
|  | unsigned | ,
|  | unsigned | ,
|  | unsigned | ,
|  | unsigned | ,
|  | const std::vector< unsigned > & | ,
|  | const std::vector< unsigned char > & | )

inline override virtual

Implements libcdr::CDRCollector.

## collectBmpf()

void libcdr::CDRContentCollector::collectBmpf | ( | unsigned | ,
|  | unsigned | ,
|  | unsigned | ,
|  | const std::vector< unsigned char > & | )

inline override virtual

Implements libcdr::CDRCollector.

## collectColorProfile()

void libcdr::CDRContentCollector::collectColorProfile | ( | const std::vector< unsigned char > & |  | ) |

inline override virtual

Implements libcdr::CDRCollector.

## collectFillOpacity()

void libcdr::CDRContentCollector::collectFillOpacity | ( | double | opacity | ) |

override virtual

Implements libcdr::CDRCollector.

## collectFillStyle()

void libcdr::CDRContentCollector::collectFillStyle | ( | unsigned | ,
|  | const CDRFillStyle & | )

inline override virtual

Implements libcdr::CDRCollector.

## collectFillStyleId()

void libcdr::CDRContentCollector::collectFillStyleId | ( | unsigned | id | ) |

override virtual

Implements libcdr::CDRCollector.

## collectFillTransform()

void libcdr::CDRContentCollector::collectFillTransform | ( | const CDRTransforms & | fillTrafo | ) |

override virtual

Implements libcdr::CDRCollector.

## collectFlags()

void libcdr::CDRContentCollector::collectFlags | ( | unsigned | flags,
|  | bool | considerFlags )

override virtual

Implements libcdr::CDRCollector.

## collectGroup()

void libcdr::CDRContentCollector::collectGroup | ( | unsigned | level | ) |

override virtual

Implements libcdr::CDRCollector.

## collectLevel()

void libcdr::CDRContentCollector::collectLevel | ( | unsigned | level | ) |

override virtual

Implements libcdr::CDRCollector.

## collectLineStyle()

void libcdr::CDRContentCollector::collectLineStyle | ( | unsigned | ,
|  | const CDRLineStyle & | )

inline override virtual

Implements libcdr::CDRCollector.

## collectLineStyleId()

void libcdr::CDRContentCollector::collectLineStyleId | ( | unsigned | id | ) |

override virtual

Implements libcdr::CDRCollector.

## collectObject()

void libcdr::CDRContentCollector::collectObject | ( | unsigned | level | ) |

override virtual

Implements libcdr::CDRCollector.

## collectOtherList()

void libcdr::CDRContentCollector::collectOtherList | ( |  | ) |

override virtual

Implements libcdr::CDRCollector.

## collectPage()

void libcdr::CDRContentCollector::collectPage | ( | unsigned | level | ) |

override virtual

Implements libcdr::CDRCollector.

## collectPageSize()

void libcdr::CDRContentCollector::collectPageSize | ( | double | ,
|  | double | ,
|  | double | ,
|  | double | )

inline override virtual

Implements libcdr::CDRCollector.

## collectPaletteEntry()

void libcdr::CDRContentCollector::collectPaletteEntry | ( | unsigned | ,
|  | unsigned | ,
|  | const CDRColor & | )

inline override virtual

Implements libcdr::CDRCollector.

## collectParagraphText()

void libcdr::CDRContentCollector::collectParagraphText | ( | double | x,
|  | double | y,
|  | double | width,
|  | double | height )

override virtual

Implements libcdr::CDRCollector.

## collectPath()

void libcdr::CDRContentCollector::collectPath | ( | const CDRPath & | path | ) |

override virtual

Implements libcdr::CDRCollector.

## collectPolygon()

void libcdr::CDRContentCollector::collectPolygon | ( |  | ) |

override virtual

Implements libcdr::CDRCollector.

## collectPolygonTransform()

void libcdr::CDRContentCollector::collectPolygonTransform | ( | unsigned | numAngles,
|  | unsigned | nextPoint,
|  | double | rx,
|  | double | ry,
|  | double | cx,
|  | double | cy )

override virtual

Implements libcdr::CDRCollector.

## collectPpdt()

void libcdr::CDRContentCollector::collectPpdt | ( | const std::vector< std::pair< double, double > > & | points,
|  | const std::vector< unsigned > & | knotVector )

override virtual

Implements libcdr::CDRCollector.

## collectRotate()

void libcdr::CDRContentCollector::collectRotate | ( | double | angle,
|  | double | cx,
|  | double | cy )

override virtual

Implements libcdr::CDRCollector.

## collectSpline()

void libcdr::CDRContentCollector::collectSpline | ( |  | ) |

override virtual

Implements libcdr::CDRCollector.

## collectSpnd()

void libcdr::CDRContentCollector::collectSpnd | ( | unsigned | spnd | ) |

override virtual

Implements libcdr::CDRCollector.

## collectStld()

void libcdr::CDRContentCollector::collectStld | ( | unsigned | ,
|  | const CDRStyle & | )

inline override virtual

Implements libcdr::CDRCollector.

## collectStyleId()

void libcdr::CDRContentCollector::collectStyleId | ( | unsigned | styleId | ) |

override virtual

Implements libcdr::CDRCollector.

## collectText()

void libcdr::CDRContentCollector::collectText | ( | unsigned | ,
|  | unsigned | ,
|  | const std::vector< unsigned char > & | ,
|  | const std::vector< unsigned char > & | ,
|  | const std::map< unsigned, CDRStyle > & | )

inline override virtual

Implements libcdr::CDRCollector.

## collectTransform()

void libcdr::CDRContentCollector::collectTransform | ( | const CDRTransforms & | transforms,
|  | bool | considerGroupTransform )

override virtual

Implements libcdr::CDRCollector.

## collectVect()

void libcdr::CDRContentCollector::collectVect | ( | unsigned | level | ) |

override virtual

Implements libcdr::CDRCollector.

## collectVectorPattern()

void libcdr::CDRContentCollector::collectVectorPattern | ( | unsigned | id,
|  | const librevenge::RVNGBinaryData & | data )

override virtual

Implements libcdr::CDRCollector.

## operator=()

CDRContentCollector & libcdr::CDRContentCollector::operator= | ( | const CDRContentCollector & |  | ) |

private

## Member Data Documentation

## m_contentOutputElementsQueue

std::queue<CDROutputElementList> libcdr::CDRContentCollector::m_contentOutputElementsQueue

private

Referenced by _endPage(), CDRContentCollector(), and collectLevel().

## m_contentOutputElementsStack

std::stack<CDROutputElementList> libcdr::CDRContentCollector::m_contentOutputElementsStack

private

Referenced by _endPage(), CDRContentCollector(), and collectLevel().

## m_currentBBox

CDRBox libcdr::CDRContentCollector::m_currentBBox

private

Referenced by _flushCurrentPath(), CDRContentCollector(), collectArtisticText(), collectBBox(), and collectObject().

## m_currentFillStyle

CDRFillStyle libcdr::CDRContentCollector::m_currentFillStyle

private

Referenced by _fillProperties(), CDRContentCollector(), collectFillStyleId(), and collectObject().

## m_currentGroupLevel

unsigned libcdr::CDRContentCollector::m_currentGroupLevel

private

Referenced by CDRContentCollector().

## m_currentImage

CDRImage libcdr::CDRContentCollector::m_currentImage

private

Referenced by _flushCurrentPath(), CDRContentCollector(), and collectBitmap().

## m_currentLineStyle

CDRLineStyle libcdr::CDRContentCollector::m_currentLineStyle

private

Referenced by _lineProperties(), CDRContentCollector(), collectLineStyleId(), and collectObject().

## m_currentObjectLevel

unsigned libcdr::CDRContentCollector::m_currentObjectLevel

private

Referenced by CDRContentCollector(), collectLevel(), collectObject(), and collectTransform().

## m_currentPageLevel

unsigned libcdr::CDRContentCollector::m_currentPageLevel

private

Referenced by CDRContentCollector(), collectLevel(), and collectPage().

## m_currentPath

CDRPath libcdr::CDRContentCollector::m_currentPath

private

Referenced by _flushCurrentPath(), CDRContentCollector(), collectPath(), and collectRotate().

## m_currentStyleId

unsigned libcdr::CDRContentCollector::m_currentStyleId

private

Referenced by _fillProperties(), _lineProperties(), CDRContentCollector(), collectObject(), and collectStyleId().

## m_currentText

const std::vector<CDRTextLine>* libcdr::CDRContentCollector::m_currentText

private

Referenced by _flushCurrentPath(), CDRContentCollector(), collectArtisticText(), and collectParagraphText().

## m_currentTextBox

CDRBox libcdr::CDRContentCollector::m_currentTextBox

private

Referenced by _flushCurrentPath(), CDRContentCollector(), collectArtisticText(), and collectParagraphText().

## m_currentTransforms

CDRTransforms libcdr::CDRContentCollector::m_currentTransforms

private

Referenced by _fillProperties(), _flushCurrentPath(), _lineProperties(), CDRContentCollector(), and collectTransform().

## m_currentVectLevel

unsigned libcdr::CDRContentCollector::m_currentVectLevel

private

Referenced by CDRContentCollector(), collectBBox(), collectGroup(), collectLevel(), collectObject(), collectSpnd(), and collectVect().

## m_fillOpacity

double libcdr::CDRContentCollector::m_fillOpacity

private

Referenced by _fillProperties(), _flushCurrentPath(), CDRContentCollector(), and collectFillOpacity().

## m_fillOutputElementsQueue

std::queue<CDROutputElementList> libcdr::CDRContentCollector::m_fillOutputElementsQueue

private

Referenced by CDRContentCollector(), collectLevel(), and collectVect().

## m_fillOutputElementsStack

std::stack<CDROutputElementList> libcdr::CDRContentCollector::m_fillOutputElementsStack

private

Referenced by CDRContentCollector(), collectLevel(), and collectVect().

## m_fillTransforms

CDRTransforms libcdr::CDRContentCollector::m_fillTransforms

private

Referenced by _fillProperties(), _flushCurrentPath(), CDRContentCollector(), and collectFillTransform().

## m_groupLevels

std::stack<unsigned> libcdr::CDRContentCollector::m_groupLevels

private

Referenced by CDRContentCollector(), collectGroup(), collectLevel(), and collectTransform().

## m_groupTransforms

std::stack<CDRTransforms> libcdr::CDRContentCollector::m_groupTransforms

private

Referenced by _flushCurrentPath(), _lineProperties(), CDRContentCollector(), collectGroup(), collectLevel(), and collectTransform().

## m_ignorePage

bool libcdr::CDRContentCollector::m_ignorePage

private

Referenced by _startPage(), CDRContentCollector(), collectFlags(), collectGroup(), collectObject(), and collectPage().

## m_isDocumentStarted

bool libcdr::CDRContentCollector::m_isDocumentStarted

private

Referenced by _endDocument(), _startDocument(), _startPage(), CDRContentCollector(), and ~CDRContentCollector().

## m_isInPolygon

bool libcdr::CDRContentCollector::m_isInPolygon

private

Referenced by _flushCurrentPath(), CDRContentCollector(), and collectPolygon().

## m_isInSpline

bool libcdr::CDRContentCollector::m_isInSpline

private

Referenced by _flushCurrentPath(), CDRContentCollector(), and collectSpline().

## m_isPageProperties

bool libcdr::CDRContentCollector::m_isPageProperties

private

Referenced by CDRContentCollector(), collectFlags(), and collectPage().

## m_isPageStarted

bool libcdr::CDRContentCollector::m_isPageStarted

private

Referenced by _endDocument(), _endPage(), _startPage(), CDRContentCollector(), collectFlags(), collectGroup(), collectObject(), and ~CDRContentCollector().

## m_outputElementsQueue

std::queue<CDROutputElementList>* libcdr::CDRContentCollector::m_outputElementsQueue

private

Referenced by _flushCurrentPath(), CDRContentCollector(), collectGroup(), collectLevel(), and collectVect().

## m_outputElementsStack

std::stack<CDROutputElementList>* libcdr::CDRContentCollector::m_outputElementsStack

private

Referenced by _flushCurrentPath(), CDRContentCollector(), collectGroup(), collectLevel(), and collectVect().

## m_page

CDRPage libcdr::CDRContentCollector::m_page

private

Referenced by _flushCurrentPath(), CDRContentCollector(), collectBBox(), collectFlags(), collectGroup(), collectLevel(), collectObject(), collectPage(), and collectVect().

## m_pageIndex

unsigned libcdr::CDRContentCollector::m_pageIndex

private

Referenced by CDRContentCollector(), collectLevel(), and collectPage().

## m_painter

librevenge::RVNGDrawingInterface* libcdr::CDRContentCollector::m_painter

private

Referenced by _endDocument(), _endPage(), _startDocument(), _startPage(), and CDRContentCollector().

## m_polygon

std::unique_ptr<CDRPolygon> libcdr::CDRContentCollector::m_polygon

private

Referenced by _flushCurrentPath(), CDRContentCollector(), and collectPolygonTransform().

## m_ps

CDRParserState& libcdr::CDRContentCollector::m_ps

private

Referenced by _fillProperties(), _flushCurrentPath(), _generateBitmapFromPattern(), _lineProperties(), CDRContentCollector(), collectArtisticText(), collectBitmap(), collectFillStyleId(), collectLevel(), collectLineStyleId(), collectPage(), collectParagraphText(), and collectVectorPattern().

## m_reverseOrder

bool libcdr::CDRContentCollector::m_reverseOrder

private

Referenced by _flushCurrentPath(), CDRContentCollector(), collectGroup(), and collectLevel().

## m_splineData

CDRSplineData libcdr::CDRContentCollector::m_splineData

private

Referenced by _flushCurrentPath(), CDRContentCollector(), and collectPpdt().

## m_spnd

unsigned libcdr::CDRContentCollector::m_spnd

private

Referenced by CDRContentCollector(), collectArtisticText(), collectLevel(), collectParagraphText(), and collectSpnd().

The documentation for this class was generated from the following files:

- CDRContentCollector.h
- CDRContentCollector.cpp